<template>
  <v-container class="mb-5 mt-6" fluid>
    <v-row justify="center" align="center">
      <v-col cols="12" xl="10" sm="11">
        <h1 class="display-2 text-left primary--text mb-4">
          {{ $t('titleCertificates') }}
        </h1>
      </v-col>
    </v-row>
    <v-row justify="center" align="center">
      <v-col cols="12" xl="10" sm="11">
        <v-card>
          <data-table-users
            v-if="!loading"
            :data="data"
            @deleteUser="deleteUser($event)"
          />
          <template v-else>
            <v-row justify="center" class="d-flex">
              <v-col xs="12" justify="center" class="text-center">
                <v-progress-circular
                  :size="50"
                  color="primary"
                  indeterminate
                ></v-progress-circular>
              </v-col>
            </v-row>
          </template>
        </v-card>
      </v-col>
    </v-row>
  </v-container>
</template>

<script lang="ts">
import _ from 'lodash'
import moment from 'moment'
import { mapGetters } from 'vuex'
import axios from 'axios'
import swal from 'sweetalert'

import { getUsers, deleteUserCollection } from '~/services/User'

import DataTableUsers from '~/components/Users/DataTableUsers.vue'
import CertificateMixin from '@/mixins/CertificateMixin'

export default CertificateMixin.extend({
  name: 'UsersManager',
  components: { DataTableUsers },
  middleware: ['admin'],
  data() {
    return {
      data: [],
      loading: false,
      urlEndpoints: process.env.OSCITY_ENDPOINTS_URL,
    }
  },
  computed: {
    ...mapGetters({
      certsConfig: 'certsConfig/certsConfig',
    }),
  },
  mounted() {
    this.getUsers()
  },
  methods: {
    async getUsers() {
      this.loading = true
      await getUsers(this.$fire)
        .then((res: any) => {
          this.data = []
          res.forEach((doc: any) => {
            if (!_.includes(['superadmin', 'operator'], doc.data().type)) {
              this.data.push(doc.data())
            }
          })
          this.data = this.data.map((element: any) => {
            return {
              ...element,
              created: moment(element.created).format('YYYY-MM-DD'),
              activated: element.activated === true ? 'Sí' : 'No',
            }
          })
        })
        .catch((error: any) => {
          console.log(error)
        })
        .finally(() => {
          this.loading = false
        })
    },
    async deleteUser(itemUid: string) {
      this.loading = true
      const nameCollections = this.certsConfig.certsCollectionsToRevoke
      const promises = [] as any
      await axios
        .post(`${this.urlEndpoints}/deleteUser`, {
          uid: itemUid,
        })
        .then(async () => {
          // User deleted.
          await deleteUserCollection(this.$fire, itemUid)
          await this.getUsers()
          nameCollections.forEach((collectionName: string) => {
            promises.push(
              this.deleteCertificatesByUser(itemUid, collectionName)
            )
          })
          Promise.all(promises)
        })
        .catch((error: any) => {
          console.error(error)
          swal({
            title: 'Error al eliminar al usuario',
            text: '' + error,
            icon: 'error',
            buttons: 'Close',
          })
        })
      this.loading = false
    },
  },
})
</script>
